;ContextMenu struct
;	pvtIShellExtInit PIShellExtInit ?
;	pvtIContextMenu PIContextMenu ?
;	RefCount dd ?
;	FileName dd ?
;	dd 3 dup (?)
;ContextMenu ends 
;PContextMenu typedef ptr ContextMenu

.data
IID_IUnknown GUID <SIID_IUnknown> 
IID_IClassFactory GUID <SIID_IClassFactory>
IID_IShellExtInit GUID <SIID_IShellExtInit>
IID_IContextMenu GUID <SIID_IContextMenu>

.data

;; IClassFactory
mycf  IClassFactory <<mycf_QueryInterface,mycf_AddRef,mycf_Release>,mycf_CreateInstance,mycf_LockServer>
pmycf dd offset mycf

;; IShellExtInit
mysei IShellExtInit <<mysei_QueryInterface,mysei_AddRef,mysei_Release>,mysei_Initialize>
pmysei dd offset mysei

;; IContextMenu
mycm IContextMenu <<mycm_QueryInterface,mycm_AddRef,mycm_Release>,mycm_QueryContextMenu,mycm_InvokeCommand,mycm_GetCommandString>
pmycm dd offset mycm

.data

RefCount dd 0

.data?
pszFile db MAX_PATH dup(?)


.code
;; IClassFactory.IUnknown

mycf_QueryInterface proc uses ebx pself:PIUnknown, iid:PGUID, ppv:DWORD
	dbg 'IClassFactoryf::QueryInterface'; self:%.8X, iid:%.8X, ppv:%.8X',pself,iid,ppv
	invoke IsEqualGUID,iid,addr IID_IUnknown
	mov ebx,eax
	invoke IsEqualGUID,iid,addr IID_IClassFactory
	or ebx,eax
	.if !zero?
		mov eax,pself;get PIClassFactory
		mov edx,ppv
		mov [edx],eax;set PIClassFactory
		mov ecx,[eax];get IClassFactory
		dbg 'my call to IClassFactory.iIUnknown.AddRef'
		invoke [ecx].IClassFactory.iIUnknown.AddRef,eax
		mov eax,S_OK
	.else
		mov edx,ppv
		mov [edx],ebx
		mov eax,E_NOINTERFACE 
	.endif
	ret
mycf_QueryInterface endp

mycf_AddRef proc pself:PIUnknown
	mov eax,ServerLockCount
	inc eax
	mov ServerLockCount,eax
	dbg 'IClassFactoryf::AddRef ServerLockCount:%.8X',ServerLockCount
	ret
mycf_AddRef endp

mycf_Release proc pself:PIUnknown
	mov eax,ServerLockCount
	dec eax
	mov ServerLockCount,eax
	dbg 'IClassFactory::Release ServerLockCount:%.8X',ServerLockCount
	ret
mycf_Release endp

;; IClassFactory.

mycf_CreateInstance proc pself:PIClassFactory, UnkOuter:PIUnknown, pguid:PGUID, ppv:DWORD
	.if UnkOuter
		mov eax,CLASS_E_NOAGGREGATION
		ret
	.endif
	invoke IsEqualGUID,pguid,addr IID_IShellExtInit
	.if !eax
		dbg 'MUSTBE IShellExtInit::QueryInterface'
		mov edx,ppv
		mov dword ptr [edx],0
		mov eax,E_NOINTERFACE
		ret
	.endif	
	dbg 'IClassFactory::CreateInstance'; pself:%.8X, UnkOuter:%.8X, pguid:%.8X, ppv:%.8X',pself,UnkOuter,pguid,ppv
;	invoke CoTaskMemAlloc,sizeof ContextMenu
;	dbg 'ContextMenu ALLOC @%.8X',eax
;	assume eax:ptr ContextMenu
;	mov [eax].pvtIShellExtInit,offset mysei
;	mov [eax].pvtIContextMenu,offset mycm
;	mov [eax].RefCount,0
;	mov [eax].FileName,0
;	mov edx,[eax].pvtIShellExtInit
;	assume eax:ptr nothing
;	dbg 'my call to IShellExtInit::QueryInterface'
;	mov eax,pIMalloc
;	mov edx,[eax]
;	invoke [edx].IMalloc.Alloc,eax,MAX_PATH
;	mov pszFile,eax
	
	invoke mysei.iIUnknown.QueryInterface,offset pmysei,pguid,ppv
	;inc ServerLockCount
;	mov eax,E_UNEXPECTED
;	mov eax,S_OK
	ret
mycf_CreateInstance endp

mycf_LockServer proc pself:PIClassFactory, fLock:BOOL
	.if fLock
		inc ServerLockCount
	.else
		dec ServerLockCount
	.endif
	dbg 'mycf_LOCKSERVER ServerLockCount:%.8X',ServerLockCount
	mov eax,S_OK
	ret
mycf_LockServer endp


.code

mysei_QueryInterface proc pself:PIUnknown, iid:PGUID, ppv:DWORD
	;dbg 'mysei_QueryInterface'
	invoke IsEqualGUID,iid,addr IID_IUnknown
	push eax
	invoke IsEqualGUID,iid,addr IID_IShellExtInit
	pop edx
	or edx,eax
	.if !zero?
		dbg 'IShellExtInit::QueryInterface'
;		mov eax,pself
		mov edx,ppv
		mov dword ptr[edx],offset pmysei;eax
		invoke mysei.iIUnknown.AddRef,offset mysei
		mov eax,S_OK
		ret
	.endif
	mov edx,ppv
	mov dword ptr [edx],0
	mov	eax,E_NOINTERFACE
	invoke mycm.iIUnknown.QueryInterface,pself,iid,ppv
	ret
mysei_QueryInterface endp

mysei_AddRef proc pself:PIUnknown
	inc RefCount
	dbg 'IShellExtInit::AddRef RefCount : %.8X',RefCount
	mov eax,S_OK
	ret
mysei_AddRef endp

mysei_Release proc pself:PIUnknown
	dec RefCount
;	.if zero?
;		mov eax,pIMalloc
;		mov edx,[eax]
;		invoke [edx].IMalloc.Free,eax,pszFile
;		dbg 'ContextMenu FREEED'
;		invoke CoTaskMemFree,pself
;	.endif
	dbg 'IShellExtInit::Release RefCount : %.8X',RefCount
	mov eax,S_OK
	ret
mysei_Release endp


mycm_QueryInterface proc pself:PIUnknown, iid:PGUID, ppv:DWORD
	;dbg 'mycm_QueryInterface'
	invoke IsEqualGUID,iid,addr IID_IUnknown
	push eax
	invoke IsEqualGUID,iid,addr IID_IContextMenu
	pop edx
	or edx,eax
	.if !zero?
		dbg 'IContextMenu::QueryInterface'
;		mov eax,pself
		mov edx,ppv
		mov dword ptr [edx],offset pmycm
		invoke mycm.iIUnknown.AddRef,offset mycm
		mov eax,S_OK
		ret
	.endif
	mov edx,ppv
	mov dword ptr [edx],0
	mov	eax,E_NOINTERFACE
	ret
mycm_QueryInterface endp

mycm_AddRef proc pself:PIUnknown
	inc RefCount
	dbg 'IContextMenu::AddRef RefCount : %.8X',RefCount
	mov eax,S_OK
	ret
mycm_AddRef endp

mycm_Release proc pself:PIUnknown
	dec RefCount
;	.if zero?
;		mov eax,pIMalloc
;		mov edx,[eax]
;		invoke [edx].IMalloc.Free,eax,pszFile
;	.endif
	dbg 'IContextMenu::Release RefCount : %.8X',RefCount
	mov eax,S_OK
	ret
mycm_Release endp

.code
;; IContextMenu.
IDM_PEINFO1 EQU 0



mycm_QueryContextMenu proc uses ebx esi edi pself:PIContextMenu, hMenu:HMENU, indexMenu:UINT, idCmdFirst:UINT, idCmdLast:UINT, uFlags: UINT
local mii:MENUITEMINFO	
	dbg 'IContextMenu::QueryContextMenu'
	mov eax,MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0)
	.if !(uFlags & (CMF_DEFAULTONLY or CMF_VERBSONLY))
		invoke CreateMenu; Auto freed? 
		mov ebx,eax
		mov edi,idCmdFirst
		invoke InsertMenu,ebx,0,MF_STRING or MF_BYPOSITION,edi,T('View &Imports')
		;invoke InsertMenu,ebx,1,MF_SEPARATOR or MF_BYPOSITION,0,0
		add edi,1
		invoke InsertMenu,ebx,2,MF_STRING or MF_BYPOSITION,edi,T('View &Exports')
		invoke ZeroMemory,addr mii,sizeof MENUITEMINFO
		mov mii.cbSize,sizeof MENUITEMINFO
		mov mii.fMask,MIIM_TYPE or MIIM_SUBMENU or MIIM_CHECKMARKS
		mov mii.hSubMenu,ebx
		mov mii.fType,MFT_STRING
		mov mii.dwTypeData,T('PE Information')
		invoke LoadBitmap,hInstance,1
		mov mii.hbmpUnchecked,eax
		invoke InsertMenuItem,hMenu,indexMenu,TRUE,addr mii 
		mov eax,MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,2+1)
	.endif
	ret
mycm_QueryContextMenu endp

.code

include viewimports.asm
include viewexports.asm

.code
mycm_InvokeCommand proc uses ebx pself:PIContextMenu, lpici:Ptr CMINVOKECOMMANDINFO
	dbg 'IContextMenu::InvokeCommand'
	mov ebx,lpici
	assume ebx:ptr CMINVOKECOMMANDINFO
	.if [ebx].lpVerb == 0
		;invoke ViewImpTable,[ebx].hwnd,addr pszFile
		invoke ViewImpTable,0,addr pszFile
		mov eax,S_OK
	.elseif [ebx].lpVerb == 1
		;invoke ViewExpTable,[ebx].hwnd,addr pszFile
		invoke ViewExpTable,0,addr pszFile
		mov eax,S_OK
	.else
		mov eax,E_FAIL	
	.endif
	assume ebx:ptr nothing
	ret
mycm_InvokeCommand endp

mycm_GetCommandString proc pself:PIContextMenu, idCmd:UINT, uFlags:UINT, pwReserved:PUINT, pszName:LPSTR, cchMax:UINT
	dbg 'IContextMenu::GetCommandString uFlags:%.8X idCmd:%.8X',uFlags,idCmd
	mov edx,uFlags
	mov eax,E_NOTIMPL
	mov ecx,idCmd
	.if ecx == IDM_PEINFO1 
		.if (edx == GCS_HELPTEXTA)
			;dbg '--GCS_HELPTEXTA'
			invoke StrCpy,pszName,T("View PE information")
			mov eax,S_OK
		.elseif (edx == GCS_VALIDATEA)
			;dbg '--GCS_VALIDATE'
			mov eax,S_OK
		.elseif (edx == GCS_VERBA)
			;dbg '--GCS_VERBA'
			invoke StrCpy,pszName,T("peinfo")
			mov eax,S_OK
		.endif
	.endif
	ret
mycm_GetCommandString endp

.code
;; IShellExtInit.

mysei_Initialize proc uses ebx esi edi pself:PIShellExtInit, pidlFolder:PITEMIDLIST, pdobj:PIDataObject, hKeyProgID:HKEY
LOCAL fetc:FORMATETC
LOCAL stg:STGMEDIUM
	.if !pdobj
		mov eax,E_INVALIDARG
		ret
	.endif
	dbg 'IShellExtInit::Initialize'
	mov fetc.cfFormat,CF_HDROP
	mov fetc.ptd,0
	mov fetc.dwAspect,DVASPECT_CONTENT
	mov fetc.lindex,-1
	mov fetc.tymed,TYMED_HGLOBAL
	mov stg.tymed,TYMED_HGLOBAL
	mov edx,pdobj
	mov ecx,[edx]
	invoke [ecx].IDataObject.GetData,edx,addr fetc,addr stg
	.if FAILED() || stg.hGlobal == 0
		mov eax,E_FAIL
		ret
	.endif
	invoke DragQueryFile,stg.hGlobal,-1,0,0
	.if !eax
		invoke ReleaseStgMedium,addr stg
		mov eax,E_FAIL
		ret
	.endif
	invoke DragQueryFile,stg.hGlobal,0,addr pszFile,MAX_PATH
	invoke ReleaseStgMedium, addr stg
	mov eax,S_OK
	ret
mysei_Initialize endp

